diff --git a/src/common/SurgeSynthesizer.cpp b/src/common/SurgeSynthesizer.cpp
index 927d5a55c..44701f204 100644
--- a/src/common/SurgeSynthesizer.cpp
+++ b/src/common/SurgeSynthesizer.cpp
@@ -3133,3 +3133,67 @@ void SurgeSynthesizer::setupActivateExtraOutputs()
    
    activateExtraOutputs = Surge::Storage::getUserDefaultValue( &(storage), "activateExtraOutputs", defval ? 1 : 0 );
 }
+
+void SurgeSynthesizer::swapMetaControllers( int c1, int c2 )
+{
+   char nt[20];
+   strncpy( nt, storage.getPatch().CustomControllerLabel[c1], 16 );
+   strncpy( storage.getPatch().CustomControllerLabel[c1], storage.getPatch().CustomControllerLabel[c2], 16 );
+   strncpy( storage.getPatch().CustomControllerLabel[c2], nt, 16 );
+
+   storage.CS_ModRouting.enter();
+
+   auto tmp1 = storage.getPatch().scene[0].modsources[ms_ctrl1 + c1];
+   auto tmp2 = storage.getPatch().scene[0].modsources[ms_ctrl1 + c2];
+
+   for( int sc=0; sc<n_scenes; ++sc )
+   {
+      storage.getPatch().scene[sc].modsources[ms_ctrl1+c2] = tmp1;
+      storage.getPatch().scene[sc].modsources[ms_ctrl1+c1] = tmp2;
+   }
+
+   // Now swap the routings
+   for( int sc=0; sc< n_scenes; ++sc )
+   {
+      for( int vt=0; vt<3; ++vt )
+      {
+         std::vector<ModulationRouting> *mv = nullptr;
+         if( sc == 0 && vt == 0 )
+         {
+            mv = &( storage.getPatch().modulation_global );
+         }
+         else if( vt == 1 )
+         {
+            mv = &( storage.getPatch().scene[sc].modulation_scene );
+         }
+         else if( vt == 2 )
+         {
+            mv = &( storage.getPatch().scene[sc].modulation_voice );
+         }
+
+         if( mv )
+         {
+            int n = mv->size();
+            for( int i=0; i<n; ++i )
+            {
+               if( mv->at(i).source_id == ms_ctrl1 + c1 )
+               {
+                  auto q = mv->at(i);
+                  q.source_id = ms_ctrl1 + c2;
+                  mv->at(i) = q;
+               }
+               else if( mv->at(i).source_id == ms_ctrl1 + c2 )
+               {
+                  auto q = mv->at(i);
+                  q.source_id = ms_ctrl1 + c1;
+                  mv->at(i) = q;
+               }
+            }
+         }
+      }
+   }
+
+   storage.CS_ModRouting.leave();
+
+   refresh_editor = true;
+}
diff --git a/src/common/SurgeSynthesizer.h b/src/common/SurgeSynthesizer.h
index 5dd02b1cd..2bdd124f0 100644
--- a/src/common/SurgeSynthesizer.h
+++ b/src/common/SurgeSynthesizer.h
@@ -176,6 +176,8 @@ class alignas(16) SurgeSynthesizer
    void incrementPatch(bool nextPrev);
    void incrementCategory(bool nextPrev);
 
+   void swapMetaControllers( int ct1, int ct2 );
+   
    std::string getUserPatchDirectory();
    std::string getLegacyUserPatchDirectory();
 
diff --git a/src/common/gui/CModulationSourceButton.cpp b/src/common/gui/CModulationSourceButton.cpp
index 267c452d3..f830518c0 100644
--- a/src/common/gui/CModulationSourceButton.cpp
+++ b/src/common/gui/CModulationSourceButton.cpp
@@ -1,10 +1,12 @@
 #include "CModulationSourceButton.h"
+#include "CSurgeSlider.h"
 #include "Colors.h"
 #include "MouseCursorControl.h"
 #include "globals.h"
 #include "ModulationSource.h"
 #include "CScalableBitmap.h"
 #include "SurgeBitmaps.h"
+#include "SurgeGUIEditor.h"
 #include "SurgeStorage.h"
 #include "SkinColors.h"
 #include <UserDefaults.h>
@@ -20,6 +22,8 @@ enum
 {
    cs_none = 0,
    cs_drag = 1,
+   cs_maybeswap = 2,
+   cs_swap = 3
 };
 
 class SurgeStorage;
@@ -350,11 +354,13 @@ CMouseEventResult CModulationSourceButton::onMouseDown(CPoint& where, const CBut
    }
    else if (buttons & kLButton)
    {
-      click_is_editpart = loc.x > (size.getWidth() - 11);   // click area for show LFO parameters arrow
-      event_is_drag = false;
-      if (listener)
-         listener->valueChanged(this);
-      return kMouseDownEventHandledButDontNeedMovedOrUpEvents;
+      /*
+      ** If you uncomment this if and have all paths set controstrate to cs_maybeswap
+      ** modulators wll also drop onto targets if you also uncomment the sge->openBlah below
+      */
+      if( is_metacontroller )
+         controlstate = cs_maybeswap;
+      return kMouseEventHandled;
    }
 
    return kMouseEventHandled;
@@ -366,6 +372,49 @@ CMouseEventResult CModulationSourceButton::onMouseUp(CPoint& where, const CButto
 {
    super::onMouseUp(where, buttons);
 
+   if( controlstate == cs_swap && dragLabel )
+   {
+      dragLabel->setVisible( false );
+      getFrame()->removeView( dragLabel );
+      dragLabel = nullptr;
+      controlstate = cs_none;
+
+      auto p = getFrame()->getViewSize();
+      auto wa = where - p.getTopLeft();
+      wa = getFrame()->getTransform().transform( wa );
+      auto v = getFrame()->getViewAt(wa);
+      auto sge = dynamic_cast<SurgeGUIEditor*>(listener);
+      if( sge )
+      {
+         auto c = dynamic_cast<CModulationSourceButton *>(v);
+         if( c && c->is_metacontroller )
+         {
+            sge->swapControllers( getTag(), c->getTag() );
+         }
+
+         auto s = dynamic_cast<CSurgeSlider *>(v);
+         if( s )
+         {
+            // See comment above when state is set to maybeswap
+            // sge->openModTypeinOnDrop( getTag(), s,  s->getTag() );
+         }
+      }
+
+      controlstate = cs_none;
+   }
+   else if( controlstate == cs_none || controlstate == cs_maybeswap )
+   {
+      auto size = getViewSize();
+      CPoint loc(where);
+      loc.offset(-size.left, -size.top);
+
+      click_is_editpart = loc.x > (size.getWidth() - 11);   // click area for show LFO parameters arrow
+      event_is_drag = false;
+      if (listener)
+         listener->valueChanged(this);
+   }
+   
+   
    if (controlstate)
    {
       endEdit();
@@ -376,6 +425,57 @@ CMouseEventResult CModulationSourceButton::onMouseUp(CPoint& where, const CButto
    return kMouseEventHandled;
 }
 
+CMouseEventResult CModulationSourceButton::onMouseMoved( CPoint &where, const CButtonState &buttons ) 
+{
+   if( controlstate == cs_maybeswap )
+   {
+      if( dragLabel == nullptr )
+      {
+         std::string lb = label;
+         if( hasAlternate && useAlternate )
+         {
+            lb = alternateLabel;
+         }
+
+         if( lb == "-" ) lb = "Drag Macro";
+
+         auto l = new CTextLabel( getViewSize(), lb.c_str() );
+         l->setTransparency(false);
+
+         CColor FrameCol, FillCol, FontCol;
+         const CColor ColEdge = CColor(46, 134, 254, 255);
+
+         FillCol = skin->getColor(Colors::ModSource::Inactive::Background, CColor(18, 52, 99, 255));
+         FrameCol = skin->getColor( Colors::ModSource::Inactive::Border, ColEdge );
+         FontCol = skin->getColor(Colors::ModSource::Inactive::Text, ColEdge); 
+
+         l->setFont( displayFont );
+         l->setBackColor( FillCol );
+         l->setFontColor( FontCol );
+         l->setFrameColor( FrameCol );
+         l->setVisible( true );
+         getFrame()->addView(l);
+         dragLabel = l;
+      }
+      controlstate = cs_swap;
+   }
+   else if( controlstate == cs_swap && dragLabel )
+   {
+      auto s = dragLabel->getViewSize();
+      auto r = s;
+      s = s.moveTo( where );
+      dragLabel->setViewSize( s );
+      dragLabel->invalid();
+      r.extend( 10, 10 );
+      getFrame()->invalid();
+      return kMouseEventHandled;
+   }
+   else
+   {
+      return CCursorHidingControl::onMouseMoved( where, buttons );
+   }
+}
+
 //------------------------------------------------------------------------------------------------
 
 void CModulationSourceButton::onMouseMoveDelta(CPoint& where,
diff --git a/src/common/gui/CModulationSourceButton.h b/src/common/gui/CModulationSourceButton.h
index 7a28980a3..4348026a8 100644
--- a/src/common/gui/CModulationSourceButton.h
+++ b/src/common/gui/CModulationSourceButton.h
@@ -85,7 +85,7 @@ class CModulationSourceButton : public CCursorHidingControl, public Surge::UI::S
    virtual void draw(VSTGUI::CDrawContext* dc) override;
    // virtual void mouse (VSTGUI::CDrawContext *pContext, VSTGUI::CPoint &where, long button = -1);
    virtual VSTGUI::CMouseEventResult onMouseDown(VSTGUI::CPoint& where, const VSTGUI::CButtonState& buttons) override;
-
+   virtual VSTGUI::CMouseEventResult onMouseMoved(VSTGUI::CPoint& where, const VSTGUI::CButtonState& buttons) override;
    virtual VSTGUI::CMouseEventResult onMouseUp(VSTGUI::CPoint& where, const VSTGUI::CButtonState& buttons) override;
    virtual VSTGUI::CMouseEventResult onMouseEntered (VSTGUI::CPoint& where, const VSTGUI::CButtonState& buttons) override {
       hovered = true;
@@ -107,6 +107,8 @@ class CModulationSourceButton : public CCursorHidingControl, public Surge::UI::S
          invalid();
       }
    }
+
+   CControl *dragLabel = nullptr;
    
    CLASS_METHODS(CModulationSourceButton, VSTGUI::CControl)
 };
diff --git a/src/common/gui/SurgeGUIEditor.cpp b/src/common/gui/SurgeGUIEditor.cpp
index 553918a13..1f0487b41 100644
--- a/src/common/gui/SurgeGUIEditor.cpp
+++ b/src/common/gui/SurgeGUIEditor.cpp
@@ -7043,3 +7043,17 @@ void SurgeGUIEditor::promptForMiniEdit( const std::string &value, const std::str
 
    minieditOverlayDone = onOK;
 }
+
+void SurgeGUIEditor::swapControllers( int t1, int t2 )
+{
+   synth->swapMetaControllers( t1 - tag_mod_source0 - ms_ctrl1,
+                               t2 - tag_mod_source0 - ms_ctrl1 );
+}
+
+void SurgeGUIEditor::openModTypeinOnDrop( int modt, CControl *sl, int slidertag )
+{
+   // check is valid modulation before I proceed
+   auto p =  synth->storage.getPatch().param_ptr[slidertag-start_paramtags];
+   int ms = modt - tag_mod_source0;
+   promptForUserValueEntry( p, sl, ms );
+}
diff --git a/src/common/gui/SurgeGUIEditor.h b/src/common/gui/SurgeGUIEditor.h
index 61c4f6af9..6d38a34b3 100644
--- a/src/common/gui/SurgeGUIEditor.h
+++ b/src/common/gui/SurgeGUIEditor.h
@@ -241,6 +241,9 @@ class SurgeGUIEditor : public EditorType, public VSTGUI::IControlListener, publi
    std::string mappingCacheForToggle = "";
    std::string tuningToHtml();
 
+   void swapControllers( int t1, int t2 );
+   void openModTypeinOnDrop( int ms, VSTGUI::CControl *sl, int tgt );
+   
    void queueRebuildUI() { queue_refresh = true; synth->refresh_editor = true; }
 
    std::string midiMappingToHtml();
